; Get reference to the program's normal entry point and the AMMU_init func.
;
        .ref _c_int00
        .ref ti_sysbios_hal_ammu_AMMU_init__I

; Put these in symbol table so debugger can list them.
;
        .global Main_hwiReset
        .global boot_stack

SIZE    .equ 32                         ; boot stack size (bytes)


; This function is used to program the AMMU before branching to the
; program's normal entry point.
;
        .sect ".boot:Main_hwiReset"     ; place this function in boot segment

Main_hwiReset:
        .asmfunc
        ldr     sp, stack_addr          ; load stack base address
        add     sp, #SIZE               ; move stack pointer to top of stack

        ; call AMMU_init() to program the ammu
        bl      ti_sysbios_hal_ammu_AMMU_init__I

        ; now branch to the original program entry point
        b       _c_int00

        .endasmfunc


boot_stack: .usect ".boot", SIZE        ; save space for the boot stack
stack_addr: .word boot_stack            ; base address of boot stack

        .end
